xref: /titanic_51/usr/src/cmd/svc/milestone/net-physical (revision 843e19887f64dde75055cf8842fc4db2171eff45)
17c478bd9Sstevel@tonic-gate#!/sbin/sh
27c478bd9Sstevel@tonic-gate#
37c478bd9Sstevel@tonic-gate# CDDL HEADER START
47c478bd9Sstevel@tonic-gate#
57c478bd9Sstevel@tonic-gate# The contents of this file are subject to the terms of the
66927f468Sdp# Common Development and Distribution License (the "License").
76927f468Sdp# You may not use this file except in compliance with the License.
87c478bd9Sstevel@tonic-gate#
97c478bd9Sstevel@tonic-gate# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
107c478bd9Sstevel@tonic-gate# or http://www.opensolaris.org/os/licensing.
117c478bd9Sstevel@tonic-gate# See the License for the specific language governing permissions
127c478bd9Sstevel@tonic-gate# and limitations under the License.
137c478bd9Sstevel@tonic-gate#
147c478bd9Sstevel@tonic-gate# When distributing Covered Code, include this CDDL HEADER in each
157c478bd9Sstevel@tonic-gate# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
167c478bd9Sstevel@tonic-gate# If applicable, add the following below this CDDL HEADER, with the
177c478bd9Sstevel@tonic-gate# fields enclosed by brackets "[]" replaced with your own identifying
187c478bd9Sstevel@tonic-gate# information: Portions Copyright [yyyy] [name of copyright owner]
197c478bd9Sstevel@tonic-gate#
207c478bd9Sstevel@tonic-gate# CDDL HEADER END
217c478bd9Sstevel@tonic-gate#
227c478bd9Sstevel@tonic-gate#
23f4b3ec61Sdh155122# Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
247c478bd9Sstevel@tonic-gate# Use is subject to license terms.
257c478bd9Sstevel@tonic-gate#
267c478bd9Sstevel@tonic-gate# Copyright (c) 1984, 1986, 1987, 1988, 1989 AT&T.
277c478bd9Sstevel@tonic-gate# All rights reserved.
287c478bd9Sstevel@tonic-gate#
297c478bd9Sstevel@tonic-gate#
307c478bd9Sstevel@tonic-gate# ident	"%Z%%M%	%I%	%E% SMI"
317c478bd9Sstevel@tonic-gate
326927f468Sdp. /lib/svc/share/smf_include.sh
336927f468Sdp. /lib/svc/share/net_include.sh
346927f468Sdp
357c478bd9Sstevel@tonic-gate#
36f4b3ec61Sdh155122# In a shared-IP zone we need this service to be up, but all of the work
377c478bd9Sstevel@tonic-gate# it tries to do is irrelevant (and will actually lead to the service
387c478bd9Sstevel@tonic-gate# failing if we try to do it), so just bail out.
39f4b3ec61Sdh155122# In the global zone and exclusive-IP zones we proceed.
407c478bd9Sstevel@tonic-gate#
41f4b3ec61Sdh155122smf_configure_ip || exit $SMF_EXIT_OK
427c478bd9Sstevel@tonic-gate
437c478bd9Sstevel@tonic-gate# Print warnings to console
447c478bd9Sstevel@tonic-gatewarn_failed_ifs() {
457c478bd9Sstevel@tonic-gate	echo "Failed to $1 interface(s): $2" >/dev/msglog
467c478bd9Sstevel@tonic-gate}
477c478bd9Sstevel@tonic-gate
487c478bd9Sstevel@tonic-gate# Make sure that the libraries essential to this stage of booting can be found.
497c478bd9Sstevel@tonic-gateLD_LIBRARY_PATH=/lib; export LD_LIBRARY_PATH
507c478bd9Sstevel@tonic-gate
517c478bd9Sstevel@tonic-gate#
527c478bd9Sstevel@tonic-gate# Cause ifconfig to not automatically start in.mpathd when IPMP groups are
537c478bd9Sstevel@tonic-gate# configured.  This is not strictly necessary but makes it so that in.mpathd
547c478bd9Sstevel@tonic-gate# will always be started explicitly from /etc/init.d/inetinit, when we're
557c478bd9Sstevel@tonic-gate# sure that /usr is mounted.
567c478bd9Sstevel@tonic-gate#
577c478bd9Sstevel@tonic-gateSUNW_NO_MPATHD=; export SUNW_NO_MPATHD
587c478bd9Sstevel@tonic-gate
597c478bd9Sstevel@tonic-gatesmf_netstrategy
607c478bd9Sstevel@tonic-gate
61f4b3ec61Sdh155122if smf_is_globalzone; then
627c478bd9Sstevel@tonic-gate	#
630ba2cbe9Sxc151355	# Bring up link aggregations and initialize security objects.
640ba2cbe9Sxc151355	# Note that link property initialization is deferred until after
650ba2cbe9Sxc151355	# IP interfaces are plumbed to ensure that the links will not
660ba2cbe9Sxc151355	# be unloaded (and the property settings lost).
67210db224Sericheng	#
68210db224Sericheng	/sbin/dladm up-aggr
690ba2cbe9Sxc151355	/sbin/dladm init-secobj
70f4b3ec61Sdh155122fi
71210db224Sericheng
72210db224Sericheng#
737c478bd9Sstevel@tonic-gate# If the system was net booted by DHCP, hand DHCP management off to the
747c478bd9Sstevel@tonic-gate# DHCP agent (ifconfig communicates to the DHCP agent through the
757c478bd9Sstevel@tonic-gate# loopback interface).
767c478bd9Sstevel@tonic-gate#
777c478bd9Sstevel@tonic-gateif [ -n "$_INIT_NET_IF" -a "$_INIT_NET_STRATEGY" = "dhcp" ]; then
787c478bd9Sstevel@tonic-gate	/sbin/dhcpagent -a
797c478bd9Sstevel@tonic-gatefi
807c478bd9Sstevel@tonic-gate
817c478bd9Sstevel@tonic-gate#
827c478bd9Sstevel@tonic-gate# The network initialization is done early to support diskless and
837c478bd9Sstevel@tonic-gate# dataless configurations.  For IPv4 interfaces that were configured by
847c478bd9Sstevel@tonic-gate# the kernel (e.g.  those on diskless machines) and not configured by
857c478bd9Sstevel@tonic-gate# DHCP, reset the netmask using the local "/etc/netmasks" file if one
867c478bd9Sstevel@tonic-gate# exists, and then reset the broadcast address based on the netmask.
877c478bd9Sstevel@tonic-gate#
887c478bd9Sstevel@tonic-gate/sbin/ifconfig -auD4 netmask + broadcast +
897c478bd9Sstevel@tonic-gate
907c478bd9Sstevel@tonic-gate#
917c478bd9Sstevel@tonic-gate# All the IPv4 and IPv6 interfaces are plumbed before doing any
927c478bd9Sstevel@tonic-gate# interface configuration.  This prevents errors from plumb failures
937c478bd9Sstevel@tonic-gate# getting mixed in with the configured interface lists that the script
947c478bd9Sstevel@tonic-gate# outputs.
957c478bd9Sstevel@tonic-gate#
967c478bd9Sstevel@tonic-gate
977c478bd9Sstevel@tonic-gate#
987c478bd9Sstevel@tonic-gate# Get the list of IPv4 interfaces to configure by breaking
997c478bd9Sstevel@tonic-gate# /etc/hostname.* into separate args by using "." as a shell separator
1007c478bd9Sstevel@tonic-gate# character.
1017c478bd9Sstevel@tonic-gate#
1027c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/hostname.*[0-9] 2>/dev/null`"
1037c478bd9Sstevel@tonic-gateif [ "$interface_names" != "/etc/hostname.*[0-9]" ]; then
1047c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
1057c478bd9Sstevel@tonic-gate	IFS="$IFS."
1067c478bd9Sstevel@tonic-gate	set -- $interface_names
1077c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
1087c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
1097c478bd9Sstevel@tonic-gate		shift
1107c478bd9Sstevel@tonic-gate		if [ "$1" = "xx0" ]; then
1117c478bd9Sstevel@tonic-gate			#
1127c478bd9Sstevel@tonic-gate			# For some unknown historical reason the xx0
1137c478bd9Sstevel@tonic-gate			# ifname is ignored.
1147c478bd9Sstevel@tonic-gate			#
1157c478bd9Sstevel@tonic-gate			shift
1167c478bd9Sstevel@tonic-gate			continue
1177c478bd9Sstevel@tonic-gate		fi
1187c478bd9Sstevel@tonic-gate		if [ $# -gt 1 -a "$2" != "/etc/hostname" ]; then
1197c478bd9Sstevel@tonic-gate			while [ $# -gt 1 -a "$1" != "/etc/hostname" ]; do
1207c478bd9Sstevel@tonic-gate				shift
1217c478bd9Sstevel@tonic-gate			done
1227c478bd9Sstevel@tonic-gate		else
1237c478bd9Sstevel@tonic-gate			inet_list="$inet_list $1"
1247c478bd9Sstevel@tonic-gate			shift
1257c478bd9Sstevel@tonic-gate		fi
1267c478bd9Sstevel@tonic-gate	done
1277c478bd9Sstevel@tonic-gatefi
1287c478bd9Sstevel@tonic-gate
1297c478bd9Sstevel@tonic-gate#
1307c478bd9Sstevel@tonic-gate# Get the list of IPv6 interfaces to configure by breaking
1317c478bd9Sstevel@tonic-gate# /etc/hostname6.* into separate args by using "." as a shell separator
1327c478bd9Sstevel@tonic-gate# character.
1337c478bd9Sstevel@tonic-gate#
1347c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/hostname6.*[0-9] 2>/dev/null`"
1357c478bd9Sstevel@tonic-gateif [ "$interface_names" != "/etc/hostname6.*[0-9]" ]; then
1367c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
1377c478bd9Sstevel@tonic-gate	IFS="$IFS."
1387c478bd9Sstevel@tonic-gate	set -- $interface_names
1397c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
1407c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
1417c478bd9Sstevel@tonic-gate		shift
1427c478bd9Sstevel@tonic-gate		if [ $# -gt 1 -a "$2" != "/etc/hostname6" ]; then
1437c478bd9Sstevel@tonic-gate			while [ $# -gt 1 -a "$1" != "/etc/hostname6" ]; do
1447c478bd9Sstevel@tonic-gate				shift
1457c478bd9Sstevel@tonic-gate			done
1467c478bd9Sstevel@tonic-gate		else
1477c478bd9Sstevel@tonic-gate			inet6_list="$inet6_list $1"
1487c478bd9Sstevel@tonic-gate			shift
1497c478bd9Sstevel@tonic-gate		fi
1507c478bd9Sstevel@tonic-gate	done
1517c478bd9Sstevel@tonic-gatefi
1527c478bd9Sstevel@tonic-gate
1537c478bd9Sstevel@tonic-gate
1547c478bd9Sstevel@tonic-gate#
1557c478bd9Sstevel@tonic-gate# Step through the IPv4 interface list and try to plumb every interface.
1567c478bd9Sstevel@tonic-gate# Generate list of plumbed and failed IPv4 interfaces.
1577c478bd9Sstevel@tonic-gate#
1587c478bd9Sstevel@tonic-gateif [ -n "$inet_list" ]; then
1597c478bd9Sstevel@tonic-gate	set -- $inet_list
1607c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
1617c478bd9Sstevel@tonic-gate		/sbin/ifconfig $1 plumb
1627c478bd9Sstevel@tonic-gate		if /sbin/ifconfig $1 inet >/dev/null 2>&1; then
1637c478bd9Sstevel@tonic-gate			inet_plumbed="$inet_plumbed $1"
1647c478bd9Sstevel@tonic-gate		else
1657c478bd9Sstevel@tonic-gate			inet_failed="$inet_failed $1"
1667c478bd9Sstevel@tonic-gate		fi
1677c478bd9Sstevel@tonic-gate		shift
1687c478bd9Sstevel@tonic-gate	done
1697c478bd9Sstevel@tonic-gate	[ -n "$inet_failed" ] && warn_failed_ifs "plumb IPv4" $inet_failed
1707c478bd9Sstevel@tonic-gatefi
1717c478bd9Sstevel@tonic-gate
172516fc7f3Shx147065# Run autoconf to connect to a WLAN if the interface is a wireless one
173516fc7f3Shx147065if [ -x /sbin/wificonfig -a -n "$inet_plumbed" ]; then
174516fc7f3Shx147065	set -- $inet_plumbed
175516fc7f3Shx147065	while [ $# -gt 0 ]; do
176516fc7f3Shx147065			if [ -r /dev/wifi/$1 ]; then
177516fc7f3Shx147065				/sbin/wificonfig -i $1 startconf >/dev/null
178516fc7f3Shx147065			fi
179516fc7f3Shx147065		shift
180516fc7f3Shx147065	done
181516fc7f3Shx147065fi
182516fc7f3Shx147065
1837c478bd9Sstevel@tonic-gate#
1847c478bd9Sstevel@tonic-gate# Step through the IPv6 interface list and plumb every interface.
1857c478bd9Sstevel@tonic-gate# Generate list of plumbed and failed IPv6 interfaces.  Each plumbed
1867c478bd9Sstevel@tonic-gate# interface will be brought up later, after processing any contents of
1877c478bd9Sstevel@tonic-gate# the /etc/hostname6.* file.
1887c478bd9Sstevel@tonic-gate#
1897c478bd9Sstevel@tonic-gateif [ -n "$inet6_list" ]; then
1907c478bd9Sstevel@tonic-gate	set -- $inet6_list
1917c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
1927c478bd9Sstevel@tonic-gate		/sbin/ifconfig $1 inet6 plumb
1937c478bd9Sstevel@tonic-gate		if /sbin/ifconfig $1 inet6 >/dev/null 2>&1; then
1947c478bd9Sstevel@tonic-gate			inet6_plumbed="$inet6_plumbed $1"
1957c478bd9Sstevel@tonic-gate		else
1967c478bd9Sstevel@tonic-gate			inet6_failed="$inet6_failed $1"
1977c478bd9Sstevel@tonic-gate		fi
1987c478bd9Sstevel@tonic-gate		shift
1997c478bd9Sstevel@tonic-gate	done
2007c478bd9Sstevel@tonic-gate	[ -n "$inet6_failed" ] && warn_failed_ifs "plumb IPv6" $inet6_failed
2017c478bd9Sstevel@tonic-gatefi
2027c478bd9Sstevel@tonic-gate
203f4b3ec61Sdh155122if smf_is_globalzone; then
2047c478bd9Sstevel@tonic-gate	#
205f4b3ec61Sdh155122	# Unfortunately, if a driver unloads and then is subsequently reloaded,
206f4b3ec61Sdh155122	# no mechanism currently exists to restore the properties of its
207f4b3ec61Sdh155122	# associated links.  Hence, we wait until after interfaces have been
208f4b3ec61Sdh155122	# plumbed (above) to initialize link properties.
2090ba2cbe9Sxc151355	#
2100ba2cbe9Sxc151355	/sbin/dladm init-linkprop
211f4b3ec61Sdh155122fi
2120ba2cbe9Sxc151355
2130ba2cbe9Sxc151355#
2147c478bd9Sstevel@tonic-gate# Process the /etc/hostname.* files of plumbed IPv4 interfaces.  If an
2157c478bd9Sstevel@tonic-gate# /etc/hostname file is not present or is empty, the ifconfig auto-dhcp
2167c478bd9Sstevel@tonic-gate# / auto-revarp command will attempt to set the address, later.
2177c478bd9Sstevel@tonic-gate#
2187c478bd9Sstevel@tonic-gate# If /etc/hostname.lo0 exists the loop below will do additional
2197c478bd9Sstevel@tonic-gate# configuration of lo0.
2207c478bd9Sstevel@tonic-gate#
2217c478bd9Sstevel@tonic-gateif [ -n "$inet_plumbed" ]; then
2227c478bd9Sstevel@tonic-gate	i4s_fail=
2237c478bd9Sstevel@tonic-gate	echo "configuring IPv4 interfaces:\c"
2247c478bd9Sstevel@tonic-gate	set -- $inet_plumbed
2257c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
2267c478bd9Sstevel@tonic-gate		inet_process_hostname /sbin/ifconfig $1 inet \
2277c478bd9Sstevel@tonic-gate		    </etc/hostname.$1 >/dev/null
2287c478bd9Sstevel@tonic-gate		[ $? != 0 ] && i4s_fail="$i4s_fail $1"
2297c478bd9Sstevel@tonic-gate		echo " $1\c"
2307c478bd9Sstevel@tonic-gate		shift
2317c478bd9Sstevel@tonic-gate	done
2327c478bd9Sstevel@tonic-gate	echo "."
2337c478bd9Sstevel@tonic-gate	[ -n "$i4s_fail" ] && warn_failed_ifs "configure IPv4" $i4s_fail
2347c478bd9Sstevel@tonic-gatefi
2357c478bd9Sstevel@tonic-gate
2367c478bd9Sstevel@tonic-gate#
2377c478bd9Sstevel@tonic-gate# Process the /etc/hostname6.* files of plumbed IPv6 interfaces.  After
2387c478bd9Sstevel@tonic-gate# processing the hostname6 file, bring the interface up.  If
2397c478bd9Sstevel@tonic-gate# /etc/hostname6.lo0 exists the loop below will do additional
2407c478bd9Sstevel@tonic-gate# configuration of lo0.
2417c478bd9Sstevel@tonic-gate#
2427c478bd9Sstevel@tonic-gateif [ -n "$inet6_plumbed" ]; then
2437c478bd9Sstevel@tonic-gate	i6_fail=
2447c478bd9Sstevel@tonic-gate	echo "configuring IPv6 interfaces:\c"
2457c478bd9Sstevel@tonic-gate	set -- $inet6_plumbed
2467c478bd9Sstevel@tonic-gate	while [ $# -gt 0 ]; do
2477c478bd9Sstevel@tonic-gate		inet6_process_hostname /sbin/ifconfig $1 inet6 \
2487c478bd9Sstevel@tonic-gate		    </etc/hostname6.$1 >/dev/null &&
2497c478bd9Sstevel@tonic-gate		    /sbin/ifconfig $1 inet6 up
2507c478bd9Sstevel@tonic-gate		[ $? != 0 ] && i6_fail="$i6_fail $1"
2517c478bd9Sstevel@tonic-gate		echo " $1\c"
2527c478bd9Sstevel@tonic-gate		shift
2537c478bd9Sstevel@tonic-gate	done
2547c478bd9Sstevel@tonic-gate	echo "."
2557c478bd9Sstevel@tonic-gate	[ -n "$i6_fail" ] && warn_failed_ifs "configure IPv6" $i6_fail
2567c478bd9Sstevel@tonic-gatefi
2577c478bd9Sstevel@tonic-gate
2587c478bd9Sstevel@tonic-gate# Run DHCP if requested. Skip boot-configured interface.
2597c478bd9Sstevel@tonic-gateinterface_names="`echo /etc/dhcp.*[0-9] 2>/dev/null`"
2607c478bd9Sstevel@tonic-gateif [ "$interface_names" != '/etc/dhcp.*[0-9]' ]; then
2617c478bd9Sstevel@tonic-gate	#
2627c478bd9Sstevel@tonic-gate	# First find the primary interface. Default to the first
2637c478bd9Sstevel@tonic-gate	# interface if not specified. First primary interface found
2647c478bd9Sstevel@tonic-gate	# "wins". Use care not to "reconfigure" a net-booted interface
2657c478bd9Sstevel@tonic-gate	# configured using DHCP. Run through the list of interfaces
2667c478bd9Sstevel@tonic-gate	# again, this time trying DHCP.
2677c478bd9Sstevel@tonic-gate	#
2687c478bd9Sstevel@tonic-gate	i4d_fail=
2697c478bd9Sstevel@tonic-gate	firstif=
2707c478bd9Sstevel@tonic-gate	primary=
2717c478bd9Sstevel@tonic-gate	ORIGIFS="$IFS"
2727c478bd9Sstevel@tonic-gate	IFS="${IFS}."
2737c478bd9Sstevel@tonic-gate	set -- $interface_names
2747c478bd9Sstevel@tonic-gate
2757c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
2767c478bd9Sstevel@tonic-gate		shift
2777c478bd9Sstevel@tonic-gate		[ -z "$firstif" ] && firstif=$1
2787c478bd9Sstevel@tonic-gate
2797c478bd9Sstevel@tonic-gate		for i in `shcat /etc/dhcp\.$1`; do
2807c478bd9Sstevel@tonic-gate			if [ "$i" = primary ]; then
2817c478bd9Sstevel@tonic-gate				primary=$1
2827c478bd9Sstevel@tonic-gate				break
2837c478bd9Sstevel@tonic-gate			fi
2847c478bd9Sstevel@tonic-gate		done
2857c478bd9Sstevel@tonic-gate
2867c478bd9Sstevel@tonic-gate		[ -n "$primary" ] && break
2877c478bd9Sstevel@tonic-gate		shift
2887c478bd9Sstevel@tonic-gate	done
2897c478bd9Sstevel@tonic-gate
2907c478bd9Sstevel@tonic-gate	[ -z "$primary" ] && primary="$firstif"
2917c478bd9Sstevel@tonic-gate	cmdline=`shcat /etc/dhcp\.${primary}`
2927c478bd9Sstevel@tonic-gate
2937c478bd9Sstevel@tonic-gate	if [ "$_INIT_NET_IF" != "$primary" ]; then
2947c478bd9Sstevel@tonic-gate		echo "starting DHCP on primary interface $primary"
2957c478bd9Sstevel@tonic-gate		/sbin/ifconfig $primary auto-dhcp primary $cmdline
2967c478bd9Sstevel@tonic-gate		# Exit code 4 means ifconfig timed out waiting for dhcpagent
2977c478bd9Sstevel@tonic-gate		[ $? != 0 ] && [ $? != 4 ] && i4d_fail="$i4d_fail $primary"
2987c478bd9Sstevel@tonic-gate	fi
2997c478bd9Sstevel@tonic-gate
3007c478bd9Sstevel@tonic-gate	set -- $interface_names
3017c478bd9Sstevel@tonic-gate
3027c478bd9Sstevel@tonic-gate	while [ $# -ge 2 ]; do
3037c478bd9Sstevel@tonic-gate		shift
3047c478bd9Sstevel@tonic-gate		cmdline=`shcat /etc/dhcp\.$1`
3057c478bd9Sstevel@tonic-gate		if [ "$1" != "$primary" -a \
3067c478bd9Sstevel@tonic-gate			"$1" != "$_INIT_NET_IF"  ]; then
3077c478bd9Sstevel@tonic-gate			echo "starting DHCP on interface $1"
3087c478bd9Sstevel@tonic-gate			/sbin/ifconfig $1 dhcp start wait 0 $cmdline
3097c478bd9Sstevel@tonic-gate			# Exit code can't be timeout when wait is 0
3107c478bd9Sstevel@tonic-gate			[ $? != 0 ] && i4d_fail="$i4d_fail $1"
3117c478bd9Sstevel@tonic-gate		fi
3127c478bd9Sstevel@tonic-gate		shift
3137c478bd9Sstevel@tonic-gate	done
3147c478bd9Sstevel@tonic-gate	IFS="$ORIGIFS"
3157c478bd9Sstevel@tonic-gate	unset ORIGIFS
3167c478bd9Sstevel@tonic-gate	[ -n "$i4d_fail" ] && warn_failed_ifs "configure IPv4 DHCP" $i4d_fail
3177c478bd9Sstevel@tonic-gatefi
3187c478bd9Sstevel@tonic-gate
3190659b2b8Sse146197# In order to avoid bringing up the interfaces that have
3200659b2b8Sse146197# intentionally been left down, perform RARP only if the system
3210659b2b8Sse146197# has no configured hostname in /etc/nodename
3220659b2b8Sse146197hostname="`shcat /etc/nodename 2>/dev/null`"
3230659b2b8Sse146197if [ "$_INIT_NET_STRATEGY" = "rarp" -o -z "$hostname" ]; then
3247c478bd9Sstevel@tonic-gate	/sbin/ifconfig -adD4 auto-revarp netmask + broadcast + up
3250659b2b8Sse146197fi
3267c478bd9Sstevel@tonic-gate
3277c478bd9Sstevel@tonic-gate#
3287c478bd9Sstevel@tonic-gate# Process IPv4 and IPv6 interfaces that failed to plumb.  Find an
3297c478bd9Sstevel@tonic-gate# alternative interface to host the addresses.
3307c478bd9Sstevel@tonic-gate#
3317c478bd9Sstevel@tonic-gate[ -n "$inet_failed" ] && move_addresses inet
3327c478bd9Sstevel@tonic-gate
3337c478bd9Sstevel@tonic-gate[ -n "$inet6_failed" ] && move_addresses inet6
3347c478bd9Sstevel@tonic-gate
3357c478bd9Sstevel@tonic-gate#
3367c478bd9Sstevel@tonic-gate# If the /etc/defaultrouter file exists, process it now so that the next
3377c478bd9Sstevel@tonic-gate# stage of booting will have access to NFS.
3387c478bd9Sstevel@tonic-gate#
3397c478bd9Sstevel@tonic-gateif [ -f /etc/defaultrouter ]; then
3407c478bd9Sstevel@tonic-gate	while read router rubbish; do
3417c478bd9Sstevel@tonic-gate		case "$router" in
3427c478bd9Sstevel@tonic-gate			'#'* | '') ;;	#  Ignore comments, empty lines
3437c478bd9Sstevel@tonic-gate			*)	/sbin/route -n add default -gateway $router ;;
3447c478bd9Sstevel@tonic-gate		esac
3457c478bd9Sstevel@tonic-gate	done </etc/defaultrouter
3467c478bd9Sstevel@tonic-gatefi
3477c478bd9Sstevel@tonic-gate
3487c478bd9Sstevel@tonic-gate#
349*843e1988Sjohnlev# If we get here and were not asked to plumb any IPv4 interfaces, look
350*843e1988Sjohnlev# for boot properties that direct us.
351*843e1988Sjohnlev#
352*843e1988Sjohnlev# - The "network-interface" property is required and indicates the
353*843e1988Sjohnlev#   interface name.
354*843e1988Sjohnlev# - The "xpv-hcp" property, if present, is used by the hypervisor
355*843e1988Sjohnlev#   tools to indicate how the specified interface should be configured.
356*843e1988Sjohnlev#   Permitted values are "dhcp" and "off", where "off" indicates static
357*843e1988Sjohnlev#   IP configuration.
358*843e1988Sjohnlev#
359*843e1988Sjohnlev# In the case where "xpv-hcp" is set to "dhcp", no further properties
360*843e1988Sjohnlev# are required or examined.
361*843e1988Sjohnlev#
362*843e1988Sjohnlev# In the case where "xpv-hcp" is not present or set to "off", the
363*843e1988Sjohnlev# "host-ip" and "subnet-mask" properties are used to configure
364*843e1988Sjohnlev# the specified interface.  The "router-ip" property, if present,
365*843e1988Sjohnlev# is used to add a default route.
366*843e1988Sjohnlev#
367*843e1988Sjohnlevnic="`/sbin/devprop network-interface`"
368*843e1988Sjohnlevif smf_is_globalzone && [ -z "$inet_list" ] && [ -n "$nic" ]; then
369*843e1988Sjohnlev	hcp="`/sbin/devprop xpv-hcp`"
370*843e1988Sjohnlev	case "$hcp" in
371*843e1988Sjohnlev	"dhcp")
372*843e1988Sjohnlev		/sbin/ifconfig $nic plumb 2>/dev/null
373*843e1988Sjohnlev		[ -n "`/sbin/ifconfig $nic 2>/dev/null`" ] && (
374*843e1988Sjohnlev			# The interface is successfully plumbed, so
375*843e1988Sjohnlev			# modify "inet_list" to force the exit code
376*843e1988Sjohnlev			# checks to work.
377*843e1988Sjohnlev			inet_list=$nic;
378*843e1988Sjohnlev			# Given that this is the only IPv4 interface,
379*843e1988Sjohnlev			# we assert that it is primary.
380*843e1988Sjohnlev			echo "starting DHCP on primary interface $primary";
381*843e1988Sjohnlev			/sbin/ifconfig $nic auto-dhcp primary;
382*843e1988Sjohnlev			# Exit code 4 means ifconfig timed out waiting
383*843e1988Sjohnlev			# for dhcpagent
384*843e1988Sjohnlev			[ $? != 0 ] && [ $? != 4 ] && \
385*843e1988Sjohnlev			    i4d_fail="$i4d_fail $nic";
386*843e1988Sjohnlev		)
387*843e1988Sjohnlev		;;
388*843e1988Sjohnlev
389*843e1988Sjohnlev	"off"|"")
390*843e1988Sjohnlev		/sbin/devprop host-ip subnet-mask router-ip | (
391*843e1988Sjohnlev			read ip;
392*843e1988Sjohnlev			read mask;
393*843e1988Sjohnlev			read router;
394*843e1988Sjohnlev			[ -n "$ip" ] && [ -n "$mask" ] && \
395*843e1988Sjohnlev				/sbin/ifconfig $nic plumb 2>/dev/null
396*843e1988Sjohnlev			[ -n "`/sbin/ifconfig $nic 2>/dev/null`" ] && (
397*843e1988Sjohnlev				# The interface is successfully
398*843e1988Sjohnlev				# plumbed, so modify "inet_list" to
399*843e1988Sjohnlev				# force the exit code checks to work.
400*843e1988Sjohnlev				inet_list=$nic;
401*843e1988Sjohnlev				/sbin/ifconfig $nic  inet $ip \
402*843e1988Sjohnlev				    netmask $mask broadcast + up 2>/dev/null;
403*843e1988Sjohnlev				[ -n "$router" ] && route add \
404*843e1988Sjohnlev				    default $router 2>/dev/null;
405*843e1988Sjohnlev			)
406*843e1988Sjohnlev		)
407*843e1988Sjohnlev		;;
408*843e1988Sjohnlev	esac
409*843e1988Sjohnlevfi
410*843e1988Sjohnlev
411*843e1988Sjohnlev#
4127c478bd9Sstevel@tonic-gate# We tell smf this service is online if any of the following is true:
4137c478bd9Sstevel@tonic-gate# - no interfaces were configured for plumbing and no DHCP failures
4147c478bd9Sstevel@tonic-gate# - any non-loopback IPv4 interfaces are up and have a non-zero address
4157c478bd9Sstevel@tonic-gate# - there are any DHCP interfaces started
4167c478bd9Sstevel@tonic-gate# - any non-loopback IPv6 interfaces are up
4177c478bd9Sstevel@tonic-gate#
4187c478bd9Sstevel@tonic-gate# If we weren't asked to configure any interfaces, exit
4197c478bd9Sstevel@tonic-gateif [ -z "$inet_list" ] && [ -z "$inet6_list" ]; then
4207c478bd9Sstevel@tonic-gate	# Config error if DHCP was attempted without plumbed interfaces
4217c478bd9Sstevel@tonic-gate	[ -n "$i4d_fail" ] && exit $SMF_EXIT_ERR_CONFIG
4227c478bd9Sstevel@tonic-gate	exit $SMF_EXIT_OK
4237c478bd9Sstevel@tonic-gatefi
4247c478bd9Sstevel@tonic-gate
4257c478bd9Sstevel@tonic-gate# Any non-loopback IPv4 interfaces with usable addresses up?
4267c478bd9Sstevel@tonic-gateif [ -n "`/sbin/ifconfig -a4u`" ]; then
4277c478bd9Sstevel@tonic-gate    	/sbin/ifconfig -a4u | while read intf addr rest; do
4287c478bd9Sstevel@tonic-gate		[ $intf = inet ] && [ $addr != 127.0.0.1 ] &&
429*843e1988Sjohnlev		[ $addr != 0.0.0.0 ] && exit $SMF_EXIT_OK
4307c478bd9Sstevel@tonic-gate	done && exit $SMF_EXIT_OK
4317c478bd9Sstevel@tonic-gatefi
4327c478bd9Sstevel@tonic-gate
4337c478bd9Sstevel@tonic-gate# Any DHCP interfaces started?
4347c478bd9Sstevel@tonic-gate[ -n "`/sbin/ifconfig -a4 dhcp status 2>/dev/null`" ] && exit $SMF_EXIT_OK
4357c478bd9Sstevel@tonic-gate
4367c478bd9Sstevel@tonic-gate# Any non-loopback IPv6 interfaces up?
4377c478bd9Sstevel@tonic-gateif [ -n "`/sbin/ifconfig -au6`" ]; then
4387c478bd9Sstevel@tonic-gate	/sbin/ifconfig -au6 | while read intf addr rest; do
439*843e1988Sjohnlev		[ $intf = inet6 ] && [ $addr != ::1/128 ] && exit $SMF_EXIT_OK
4407c478bd9Sstevel@tonic-gate	done && exit $SMF_EXIT_OK
4417c478bd9Sstevel@tonic-gatefi
4427c478bd9Sstevel@tonic-gate
4437c478bd9Sstevel@tonic-gate# This service was supposed to configure something yet didn't.  Exit
4447c478bd9Sstevel@tonic-gate# with config error.
4457c478bd9Sstevel@tonic-gateexit $SMF_EXIT_ERR_CONFIG
446